@prefix ottr: <http://ns.ottr.xyz/0.4/> .

[generate-indecies-0:
  (?ins ottr:arguments ?args)
  ->
  (?args ottr:posindex "0"^^xsd:integer)
]

[generate-indecies-s:
  (?args ottr:posindex ?j),
  listLength(?args, ?l),
  addOne(?j, ?i)
  lessThan(?i, ?l),
  ->
  (?args ottr:posindex ?i)
]

# listEntry is 0-based but ottr:index is 1-based, hence the addOne(?ind, ?i)
[list-to-index:
  (?ins rdf:type ottr:Instance),
  (?ins ottr:arguments ?args),
  (?args ottr:posindex ?ind),
  listEntry(?args, ?ind, ?v),
  addOne(?ind, ?i),
  makeSkolem(?newarg, ?args, ?i)
  ->
  (?ins ottr:argument ?newarg),
  (?newarg ottr:index ?i),
  (?newarg ottr:value ?v)
]

# Expand only if not template pattern and no none-args to mandatory parameters
[expand-ins:
  (?ins rdf:type ottr:Instance),
  noValue(?sometemp, ottr:pattern, ?ins),
  (?ins ottr:of ?temp),
  not(?ins, ottr:argument, ?arg,
      ?arg, ottr:value, ottr:none,
      ?arg, ottr:index, ?i,
      ?temp, ottr:parameter, ?par,
      ?par, ottr:index, ?i,
      ?par, ottr:modifier, ottr:mandatory)
  ->
  (?ins rdf:type ottr:ExpandableInstance)
]

[expand-vars: 
  (?ins rdf:type ottr:ExpandableInstance),
  (?ins ottr:of ?temp),
  (?ins ottr:argument ?iarg),
  (?iarg ottr:index ?i),
  (?iarg ottr:value ?v),
  (?temp ottr:parameter ?param),
  (?param ottr:index ?i),
  (?param ottr:variable ?x ),
  (?temp ottr:pattern ?pat),
  (?pat ottr:of ?ins2),
  (?pat ottr:argument ?parg),
  (?parg ottr:index ?j),
  (?parg ottr:value ?x),
  makeSkolem(?newins, ?ins, ?pat),
  makeSkolem(?newarg, ?ins, ?pat, ?j)
  ->
  (?newins rdf:type ottr:Instance),
  (?newins ottr:of ?ins2),
  (?newins ottr:argument ?newarg),
  (?newarg ottr:index ?j),
  (?newarg ottr:value ?v)
]

[expand-cons:
  (?ins rdf:type ottr:ExpandableInstance),
  (?ins ottr:of ?temp),
  (?temp ottr:parameter ?param),
  (?temp ottr:pattern ?pat),
  (?pat ottr:of ?ins2),
  (?pat ottr:argument ?parg),
  (?parg ottr:index ?j),
  (?parg ottr:value ?v),
  noValue(?someparam, ottr:variable, ?v),
  makeSkolem(?newins, ?ins, ?pat),
  makeSkolem(?newarg, ?ins, ?pat, ?j)
  ->
  (?newins rdf:type ottr:Instance),
  (?newins ottr:of ?ins2),
  (?newins ottr:argument ?newarg),
  (?newarg ottr:index ?j),
  (?newarg ottr:value ?v)
]

[rewrite-triples:
  (?ins rdf:type ottr:ExpandableInstance),
  (?ins ottr:of ottr:Triple),
  (?ins ottr:argument ?arg1),
  (?arg1 ottr:index 1),
  (?arg1 ottr:value ?s),
  noValue(?someparam1, ottr:variable, ?s),
  (?ins ottr:argument ?arg2),
  (?arg2 ottr:index 2),
  (?arg2 ottr:value ?p),
  noValue(?someparam2, ottr:variable, ?p),
  (?ins ottr:argument ?arg3),
  (?arg3 ottr:index 3),
  (?arg3 ottr:value ?o),
  noValue(?someparam3, ottr:variable, ?o)
  ->
  (?s, ?p, ?o)
]

